# -*- coding: utf-8 -*-

import pytest

import datetime
import dingguo
import yaml
import os

def test_sum_init_eur():
    assert dingguo.Sum(1.23, u'EUR') == dingguo.Sum(1.23, u'€')

def test_sum_init_usd():
    assert dingguo.Sum(1.23, u'USD') == dingguo.Sum(1.23, u'US$')

def test_distance_metres():
    assert int(dingguo.Distance(1.23, u'km').metres) == 1230

def test_person_first_name():
    p = dingguo.Person()
    p.first_name = u'äbc'
    assert p.first_name == u'äbc'
    p.first_name = u'qrßtuvw'
    assert p.first_name == u'qrßtuvw'

def test_person_first_name_string():
    p = dingguo.Person()
    with pytest.raises(Exception):
        p.first_name = 'äbc'

def test_person_last_name():
    p = dingguo.Person()
    p.last_name = u'歌曲'
    assert p.last_name == u'歌曲'
    p.last_name = u'bär'
    assert p.last_name == u'bär'

def test_person_last_name_string():
    p = dingguo.Person()
    with pytest.raises(Exception):
        p.last_name = 'äbc'
